// sNZVF[_[̓
struct PS_INPUT
{
	float4 Diffuse         : COLOR0 ;       // fBt[YJ[
	float4 Specular        : COLOR1 ;       // XyLJ[
	float2 TexCoords0      : TEXCOORD0 ;    // eNX`W
	float2 ToonCoords0     : TEXCOORD1 ;    // gD[eNX`W
} ;

// sNZVF[_[̏o
struct PS_OUTPUT
{
	float4 Color0          : SV_TARGET0 ;	// F
} ;


// 萔obt@sNZVF[_[{p[^
struct DX_D3D11_PS_CONST_BUFFER_BASE
{
	float4		FactorColor ;			// At@l

	float		MulAlphaColor ;			// J[ɃAt@lZ邩ǂ( 0.0f:ZȂ  1.0f:Z )
	float		AlphaTestRef ;			// At@eXgŎgprl
	float2		Padding1 ;

	int			AlphaTestCmpMode ;		// At@eXgr[h( DX_CMP_NEVER Ȃ )
	int3		Padding2 ;

	float4		IgnoreTextureColor ;	// eNX`J[pJ[
} ;

// {p[^
cbuffer cbD3D11_CONST_BUFFER_PS_BASE				: register( b1 )
{
	DX_D3D11_PS_CONST_BUFFER_BASE		g_Base ;
} ;


SamplerState g_DiffuseMapSampler            : register( s0 ) ;		// fBt[Y}bveNX`
Texture2D    g_DiffuseMapTexture            : register( t0 ) ;		// fBt[Y}bveNX`
SamplerState g_ToonDiffuseGradSampler       : register( s1 ) ;		// gD[_OpfBt[YJ[Of[VeNX`
Texture2D    g_ToonDiffuseGradTexture       : register( t1 ) ;		// gD[_OpfBt[YJ[Of[VeNX`



// main֐
PS_OUTPUT main( PS_INPUT PSInput )
{
	PS_OUTPUT PSOutput ;
	float4 TextureDiffuseColor ;
	float4 ToonColor ;

	// eNX`J[̎擾
	TextureDiffuseColor = g_DiffuseMapTexture.Sample( g_DiffuseMapSampler, PSInput.TexCoords0 ) ;

	// gD[eNX`J[擾
	ToonColor = g_ToonDiffuseGradTexture.Sample( g_ToonDiffuseGradSampler, PSInput.ToonCoords0 ) ;

	// o = saturate( fBt[YJ[ * gD[eNX`J[ + XyLJ[ ) * eNX`J[
	PSOutput.Color0.rgb = saturate( PSInput.Diffuse.rgb * ToonColor.rgb + PSInput.Specular.rgb ) * TextureDiffuseColor.rgb ;

	// At@l = fBt[YAt@ * }eÃfBt[YAt@ * sx
	PSOutput.Color0.a = TextureDiffuseColor.a * PSInput.Diffuse.a * g_Base.FactorColor.a ;


	// o̓p[^Ԃ
	return PSOutput ;
}


